<?

/***************************************************************************
*                            Dolphin Smart Community Builder
*                              -------------------
*     begin                : Mon Mar 23 2006
*     copyright            : (C) 2007 BoonEx Group
*     website              : http://www.boonex.com
* This file is part of Dolphin - Smart Community Builder
*
* Dolphin is free software; you can redistribute it and/or modify it under
* the terms of the GNU General Public License as published by the
* Free Software Foundation; either version 2 of the
* License, or  any later version.
*
* Dolphin is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
* without even the implied warranty of  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License for more details.
* You should have received a copy of the GNU General Public License along with Dolphin,
* see license.txt file; if not, write to marketing@boonex.com
***************************************************************************/

bx_import('BxDolModuleDb');

class BxArlDb extends BxDolModuleDb {	
    var $_oConfig;
	/*
	 * Constructor.
	 */
	function BxArlDb(&$oConfig) {
		parent::BxDolModuleDb($oConfig);

		$this->_oConfig = &$oConfig;
	}
	/**
	 * Delete articles.
	 *
	 * @param integer/array $mixed ID or an array of ID-s.
	 * @return boolean result of operation.
	 */
	function deleteArticles($mixed) {
	    if(!is_array($mixed))
            $mixed = array($mixed);

	    $sSql = "DELETE FROM `" . $this->_sPrefix . "entries` WHERE `id` IN ('" . implode("', '", $mixed) . "')";
	    return $this->query($sSql) > 0;
	}
	/**
	 * Update articles.
	 *
	 * @param integer/array $mixed ID or an array of ID-s.
	 * @param array $aValues key/value pears to be saved in the DB.
	 * @return boolean result of operation.
	 */
	function updateArticles($mixed, $aValues) {
	    if(!is_array($mixed))
            $mixed = array($mixed);
	    
	    $sSql = "";
	    foreach($aValues as $sKey => $sValue) 
	       $sSql .= "`" . $sKey . "`='" . $sValue . "', ";
	    $sSql = "UPDATE `" . $this->_sPrefix . "entries` SET " . substr($sSql, 0, -2) . " WHERE `id` IN ('" . implode("', '", $mixed) . "')";
	    return $this->query($sSql) > 0;
	}
	function getCount($aParams = array()) {
	    if(!isset($aParams['sample_type']))
            $aParams['sample_type'] = '';

	    switch($aParams['sample_type']) {	        
	        case 'featured':
	            $sWhereClause = "`status`='" . BX_TD_STATUS_ACTIVE . "' AND `featured`='1'";
	            break;
            case 'admin':
	            $sWhereClause = "1";
	            break;
            default:
	            $sWhereClause = "`status`='" . BX_TD_STATUS_ACTIVE . "'";
	            break;
	    }
	    $sSql = "SELECT COUNT(`id`) FROM `" . $this->_sPrefix . "entries` WHERE " . $sWhereClause . " LIMIT 1";
	    return (int)$this->getOne($sSql);
	}
	function getArticles($aParams = array()) {
	    switch($aParams['sample_type']) {
	        case 'id':	        
	            $sMethod = 'getRow';
	            $sSelectClause = "`te`.`content` AS `content`, ";
	            $sWhereClause = " AND `te`.`id`='" . $aParams['id'] . "'";
	            $sOrderClause = "`te`.`date` DESC";
	            $sLimitClause = "LIMIT 1";
	            break;
	        case 'uri':
	            $sMethod = 'getRow';
	            $sSelectClause = "`te`.`content` AS `content`, ";
	            $sWhereClause = " AND `te`.`uri`='" . $aParams['uri'] . "'";
	            $sOrderClause = "`te`.`date` DESC";
	            $sLimitClause = "LIMIT 1";
	            break;
            case 'view':
	            $sMethod = 'getAll';
	            $sSelectClause = "`te`.`content` AS `content`, ";
	            $sWhereClause = " AND `te`.`uri`='" . $aParams['uri'] . "' AND `te`.`status`='" . BX_TD_STATUS_ACTIVE . "'";
	            $sOrderClause = "`te`.`date` DESC";
	            $sLimitClause = "LIMIT 1";
	            break;
	        case 'search_unit':
	            $sMethod = 'getAll';
	            $sSelectClause = "SUBSTRING(`te`.`content`, 1, " . $this->_oConfig->getSnippetLength() . ") AS `content`, ";
	            $sWhereClause = " AND `te`.`uri`='" . $aParams['uri'] . "'";
	            $sOrderClause = "`te`.`date` DESC";
	            $sLimitClause = "LIMIT 1";
	            break;
	        case 'archive':
	            $sMethod = 'getAll';
	            $sSelectClause = "SUBSTRING(`te`.`content`, 1, " . $this->_oConfig->getSnippetLength() . ") AS `content`, ";
	            $sWhereClause = " AND `te`.`status`='" . BX_TD_STATUS_ACTIVE . "'";
	            $sOrderClause = "`te`.`date` DESC";
	            $sLimitClause = "LIMIT " . (int)$aParams['start'] . ', ' . (int)$aParams['count'];
	            break;
            case 'featured':
	            $sMethod = 'getAll';
	            $sSelectClause = "SUBSTRING(`te`.`content`, 1, " . $this->_oConfig->getSnippetLength() . ") AS `content`, ";
	            $sWhereClause = " AND `te`.`status`='" . BX_TD_STATUS_ACTIVE . "' AND `te`.`featured`='1'";
	            $sOrderClause = "`te`.`date` DESC";
	            $sLimitClause = "LIMIT " . (int)$aParams['start'] . ', ' . (int)$aParams['count'];
	            break;
            case 'top_rated':
	            $sMethod = 'getAll';
	            $sSelectClause = "SUBSTRING(`te`.`content`, 1, " . $this->_oConfig->getSnippetLength() . ") AS `content`, ";
	            $sWhereClause = " AND `te`.`status`='" . BX_TD_STATUS_ACTIVE . "'";
	            $sOrderClause = "`te`.`rate` DESC";
	            $sLimitClause = "LIMIT " . (int)$aParams['start'] . ', ' . (int)$aParams['count'];
	            break;
            case 'popular':
	            $sMethod = 'getAll';
	            $sSelectClause = "SUBSTRING(`te`.`content`, 1, " . $this->_oConfig->getSnippetLength() . ") AS `content`, ";
	            $sWhereClause = " AND `te`.`status`='" . BX_TD_STATUS_ACTIVE . "'";
	            $sOrderClause = "`te`.`view_count` DESC";
	            $sLimitClause = "LIMIT " . (int)$aParams['start'] . ', ' . (int)$aParams['count'];
	            break;	        
	        case 'admin':
	            $sMethod = 'getAll';
	            $sSelectClause = "SUBSTRING(`te`.`content`, 1, " . $this->_oConfig->getSnippetLength() . ") AS `content`, ";
	            $sWhereClause = !empty($aParams['filter_value']) ? " AND (`caption` LIKE '%" . $aParams['filter_value'] . "%' OR `content` LIKE '%" . $aParams['filter_value'] . "%' OR `tags` LIKE '%" . $aParams['filter_value'] . "%')" : "";
	            $sOrderClause = "`te`.`date` DESC";
	            $sLimitClause = "LIMIT " . $aParams['start'] . ', ' . $aParams['count'];
	            break;
            case 'all':
	            $sMethod = 'getAll';
	            $sSelectClause = "SUBSTRING(`te`.`content`, 1, " . $this->_oConfig->getSnippetLength() . ") AS `content`, ";
	            $sWhereClause = " AND `te`.`status`='" . BX_TD_STATUS_ACTIVE . "'";
	            $sOrderClause = "`te`.`date` DESC";
	            break;	            
	    }
	    $sSql = "SELECT
	               " . $sSelectClause . "
	               `te`.`id` AS `id`,
	               `te`.`caption` AS `caption`,
	               `te`.`uri` AS `uri`,
	               `te`.`tags` AS `tags`,
	               `te`.`categories` AS `categories`,
	               `te`.`comment` AS `comment`,
	               `te`.`vote` AS `vote`,
	               DATE_FORMAT(FROM_UNIXTIME(`te`.`date`), '" . $this->_oConfig->getDateFormat() . "') AS `date_uf`,
	               `te`.`date` AS `date`,
	               `te`.`status` AS `status`,
	               `te`.`featured` AS `featured`,
	               `te`.`cmts_count` AS `cmts_count`
                FROM `" . $this->_sPrefix . "entries` AS `te`
                WHERE 1 " . $sWhereClause . "
                ORDER BY " . $sOrderClause . " " . $sLimitClause;

	    $aResult = $this->$sMethod($sSql);

	    if(!in_array($aParams['sample_type'], array('id', 'uri', 'view')))
	       for($i = 0; $i < count($aResult); $i++)
	           $aResult[$i]['content'] = strip_tags($aResult[$i]['content']);

	    return $aResult;
	}
	
	function getByMonth($iYear, $iMonth, $iNextYear, $iNextMonth) {
	    $sSql = "SELECT 
	           *, 
	           DAYOFMONTH(FROM_UNIXTIME(`date`)) AS `Day`
            FROM `" . $this->_sPrefix . "entries`
            WHERE `date` >= UNIX_TIMESTAMP('" . $iYear . "-" . $iMonth . "-1') AND `Date` < UNIX_TIMESTAMP('" . $iNextYear . "-" . $iNextMonth . "-1') AND `status` = '0'";
	    return $this->getAll($sSql);
	}
}
?>