<?
/***************************************************************************
*                            Dolphin Smart Community Builder
*                              -------------------
*     begin                : Mon Mar 23 2006
*     copyright            : (C) 2007 BoonEx Group
*     website              : http://www.boonex.com
* This file is part of Dolphin - Smart Community Builder
*
* Dolphin is free software; you can redistribute it and/or modify it under
* the terms of the GNU General Public License as published by the
* Free Software Foundation; either version 2 of the
* License, or  any later version.
*
* Dolphin is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
* without even the implied warranty of  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License for more details.
* You should have received a copy of the GNU General Public License along with Dolphin,
* see license.txt file; if not, write to marketing@boonex.com
***************************************************************************/

bx_import('BxDolFilesModule');
define('PROFILE_VIDEO_CATEGORY', 'Profile videos');

class BxVideosModule extends BxDolFilesModule {
    function BxVideosModule (&$aModule) {
        parent::BxDolFilesModule($aModule);
    }
    
    function serviceGetProfileCat () {
        return PROFILE_VIDEO_CATEGORY;
    }
    
	function actionAlbumsViewMy ($sParamValue = '', $sParamValue1 = '', $sParamValue2 = '', $sParamValue3 = '') {
		$sAction = bx_get('action');
		if ($sAction !== false) {
			require_once('BxVideosUploader.php');
			$oUploader = new BxVideosUploader();

			switch($sAction) {
				case 'accept_upload':
					echo $oUploader->serviceAcceptFile(); exit;
					break;
				case 'accept_record':
					echo $oUploader->serviceAcceptRecordFile(); exit;
					break;
				case 'accept_embed':
					echo $oUploader->serviceAcceptEmbedFile(); exit;
					break;
				case 'cancel_file':
					echo $oUploader->serviceCancelFileInfo(); exit;
					break;
				case 'accept_file_info':
					echo $oUploader->serviceAcceptFileInfo(); exit;
					break;

				case 'accept_multi_files':
					echo $oUploader->servicePerformMultiVideoUpload(); exit;
					break;

				default:
					break;
			}
		} else {
			parent::actionAlbumsViewMy($sParamValue, $sParamValue1, $sParamValue2, $sParamValue3);
		}
	}
	
    function getEmbedCode ($iFileId, $aExtra = array()) {
        return $this->_oTemplate->getEmbedCode($iFileId, $aExtra);
    }
    
    function getAdminMainPage (&$aMenu, $sParam = '') {
        $sParam = clear_xss($sParam);
    	$GLOBALS['oAdmTemplate']->addLocation($this->_oConfig->getUri(), $this->_oConfig->getHomePath(), $this->_oConfig->getHomeUrl());
        $sClassName = $this->_oConfig->getClassPrefix() . 'Search';
        bx_import('Search', $this->_aModule);
        $oSearch = new $sClassName();
        $oSearch->clearFilters();
        $oSearch->bAdminMode = true;
        $oSearch->id = 1;
        $sModPref = $this->_oConfig->getMainPrefix();
        $oSearch->aCurrent['paginate']['perPage'] = (int)getParam($sModPref . '_all_count');
        $oSearch->aCurrent['restriction']['activeStatus']['value'] = mb_strlen($sParam) > 0 ? $sParam : 'approved';
        $bAjaxMode = (isset($_SERVER['HTTP_X_REQUESTED_WITH']) && $_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest') ? true : false;
        
        // array of sections
        $aSections = array(
        	'approved' => array(
        		'exclude_btns' => 'none'
        	),
        	'disapproved' => array(
        		'exclude_btns' => array('deactivate', 'featured', 'unfeatured')
        	),
        	'pending' => array(
        		'exclude_btns' => array('activate', 'deactivate', 'featured', 'unfeatured')
        	),
        	'processing' => array(
        		'exclude_btns' => 'all'
        	),
        	'failed' => array(
        		'exclude_btns' => array('activate', 'deactivate', 'featured', 'unfeatured')
        	)
        );
        if (isset($aSections[$sParam]))
        	$aSections[$sParam]['active'] = 1;
    	else
    		$aSections['approved']['active'] = 1;
        
		// array of buttons
        $aBtnsArray = $this->_oConfig->getActionArray();
        // making search result box menu
    	if ($aSections[$sParam]['exclude_btns'] == 'all')
    		$aBtnsArray = array();
    	elseif (is_array($aSections[$sParam]['exclude_btns'])) {
    		foreach ($aSections[$sParam]['exclude_btns'] as $sValue)
    			unset($aBtnsArray['action_' . $sValue]);
    	}

        foreach ($aSections as $sKey => $aValue) {
        	$aSections[$sKey]['href'] = BX_DOL_URL_ROOT . $this->_oConfig->getBaseUri() . 'administration/home/' . $sKey;
        	$aSections[$sKey]['title'] = _t('_' . $sModPref . '_' . $sKey);
        }
        if (!empty($aBtnsArray)) {
	        $aBtns = array();
	        foreach ($aBtnsArray as $sKey => $aValue)
	            $aBtns[$sKey] = _t($aValue['caption']);
	        $sManage = $oSearch->showAdminActionsPanel($oSearch->aCurrent['name'] . '_admin_form', $aBtns);
        }
        else {
        	$sManage = '';
        	$oSearch->bAdminMode = false;
        }
        
        if ($bAjaxMode) {
            $oSearch->aCurrent['restriction']['activeStatus']['value'] = process_db_input($sParam, BX_TAGS_STRIP);
            $sPostOwner = bx_get('owner');
            $sOwner = $sPostOwner !== false ? process_db_input($sPostOwner, BX_TAGS_STRIP) : '';
            if (strlen($sOwner) > 0)
                $oSearch->aCurrent['restriction']['owner']['value'] = getID($sOwner);
            $sCode = $oSearch->displayResultBlock();            
            $aCode = $this->getResultCodeArray($oSearch, $sCode);
            echo $this->_oTemplate->getFilesBox($aCode);
            exit;
        }
        $aInputs['status'] = array('type'=>'hidden');
        $aUnits = array(
        	'head' => $this->_oTemplate->getHeaderCode(),
        	'module_prefix' => $sModPref,
        	'search_form' => DesignBoxAdmin(_t('_' . $sModPref . '_admin'), $this->_oTemplate->getSearchForm($aInputs), $aMenu),
        );
        
        $sCode = $oSearch->displayResultBlock();
        $aCode = $this->getResultCodeArray($oSearch, $sCode);
        $sCode = $this->_oTemplate->getFilesBox($aCode, 'page_block_' . $oSearch->id);
        $aUnits['files'] = DesignBoxAdmin(_t('_' . $sModPref), $sCode, $aSections, $sManage);
        return $this->_oTemplate->parseHtmlByName('media_admin.html', $aUnits);
    }
    
    function getResultCodeArray (&$oSearch, $sCode) {
    	$aCode = array(
    		'code' => MsgBox(_t('_Empty')),
    		'paginate' => ''
    	);
    	$iCount = $oSearch->aCurrent['paginate']['totalNum'];
    	if ($iCount > 0) {
            $aCode['code'] = $GLOBALS['oFunctions']->centerContent($sCode, '.sys_file_search_unit');
	        $sLink = BX_DOL_URL_ROOT . $this->_oConfig->getBaseUri() . 'administration/home/' . $oSearch->aCurrent['restriction']['activeStatus']['value'];
	        $sKeyWord = bx_get('keyword');
	        if ($sKeyWord !== false)
	        	$sLink .= '&keyword=' . clear_xss($sKeyWord);
	        $aExclude = array('r');
	        $aLinkAddon = $oSearch->getLinkAddByPrams($aExclude);
	        $oPaginate = new BxDolPaginate(array(
	            'page_url' => $sLink,
	        	'count' => $iCount,
	            'per_page' => $oSearch->aCurrent['paginate']['perPage'],
	            'page' => $oSearch->aCurrent['paginate']['page'],
	            'per_page_changer' => true,
	            'page_reloader' => true,
	            'on_change_page' => 'return !loadDynamicBlock(' . $oSearch->id . ', \'' . $sLink . '&'. $aLinkAddon['params'] . $aLinkAddon['paginate'] . '\');',
	        ));
            $aCode['paginate'] = $oPaginate->getPaginate();
    	}
        return $aCode;
    }
    
    function serviceGetWallData(){
        return array(
            'handlers' => array(
                array(
                    'alert_unit' => 'bx_videos', 
                    'alert_action' => 'add', 
                    'module_uri' => 'videos', 
                    'module_class' => 'Search', 
                    'module_method' => 'get_wall_post'
                )
            ),
            'alerts' => array(
                array('unit' => 'bx_videos', 'action' => 'add')
            )
        );
    }
}

?>